#ifndef __GAME_MAP_H__
#define __GAME_MAP_H__

#include "MTGame.h"

using namespace cocos2d;



//̳CCTMXTIledMap
class GameMap : public cocos2d::CCTMXTiledMap
{
	//ֻȡͼ
	CC_PROPERTY_READONLY(CCTMXLayer*, floorLayer, FloorLayer);
	CC_PROPERTY_READONLY(CCTMXLayer*, wallLayer, WallLayer);
	CC_PROPERTY_READONLY(CCTMXLayer*, enemyLayer, EnemyLayer);
	CC_PROPERTY_READONLY(CCTMXLayer*, itemLayer, ItemLayer);
	CC_PROPERTY_READONLY(CCTMXLayer*, doorLayer, DoorLayer);
public:
	GameMap(void);
	~GameMap(void);
	//̬GameMapʵ
	static GameMap* gameMapWithTMXFile(const char *tmxFile);
	//TiledMapcocos2d-xϵ໥תķ
	CCPoint tileCoordForPosition(CCPoint position);
	CCPoint positionForTileCoord(CCPoint tileCoord);
	void showEnemyHitEffect(CCPoint tileCoord);
	CCArray *enemyArray;
	CCDictionary *teleportDict;
	CCDictionary *npcDict;
protected:
	//TiledMapĳʼ
	void extraInit();
	//ʼ
	void initEnemy();
	//ʼ
	void initObject();
	//ͼ
	void enableAnitiAliasForEachLayer();
	//¹ﶯ
	void updateEnemyAnimation(float dt);
	//ʱսʱĹ
	CCSprite* fightingEnemy;
	//ʱ
	int fightCount;
	//¹սʱɫ״̬
	void updateEnemyHitEffect(float dt);
};

#endif