#include "Hero.h"

Hero::Hero()
{
	sGlobal->hero = this;
}

Hero::~Hero()
{

}

//̬Heroʵ
Hero* Hero::heroWithinLayer()
{
	//newһ
	Hero *pRet = new Hero();
	//init
	if (pRet && pRet->heroInit())
	{
		////ʵautoreleaseأͳһƶ
		pRet->autorelease();
		return pRet;
	}
	CC_SAFE_DELETE(pRet);
	return NULL;
}

bool Hero::heroInit()
{
	//߶ĵһ֡
	CCAnimationFrame* pAnimationFrame = dynamic_cast<CCAnimationFrame*>(sAnimationMgr->getAnimation(kDown)->getFrames()->objectAtIndex(0));
	CCSpriteFrame* defaultFrame = pAnimationFrame->getSpriteFrame();
	heroSprite = CCSprite::createWithSpriteFrame(defaultFrame);
	//ê
	heroSprite->setAnchorPoint(CCPointZero);
	//ʾheroSpriteӵԼĽڵ
	this->addChild(heroSprite);
	//յս
	fightSprite = CCSprite::create("transparent.png");
	this->addChild(fightSprite);
	//һʼmove״̬
	isHeroMoving = false;
	isHeroFighting = false;
	isDoorOpening = false;
	return true;
}

void Hero::move(HeroDirection direction) 
{
	if (isHeroMoving)
		return;

	//ƶľ
	CCPoint moveByPosition;
	//ݷƶľ
	switch (direction)
	{
	case kDown:
		moveByPosition = ccp(0, -32);
		break;
	case kLeft:
		moveByPosition = ccp(-32, 0);
		break;
	case kRight:
		moveByPosition = ccp(32, 0);
		break;
	case kUp:
		moveByPosition = ccp(0, 32);
		break;
	}
	//Ŀ꣬õǰʿƶ
	targetPosition = ccpAdd(this->getPosition(), moveByPosition);
	//checkCollisionײͣǽڡţֻҪʿĳ
	CollisionType collisionType = checkCollision(targetPosition);
	if (collisionType == kWall || collisionType == kEnemy || collisionType == kDoor || collisionType == kNPC)
	{
		setFaceDirection((HeroDirection)direction);
		return;
	}
	//heroSprite߶
	heroSprite->runAction(sAnimationMgr->createAnimate(direction));
	//λƣʱonMoveDone
	CCAction *action = CCSequence::create(
		CCMoveBy::create(0.20f, moveByPosition),
		//ѷϢݸonMoveDone
		CCCallFuncND::create(this, callfuncND_selector(Hero::onMoveDone), (void*)direction),
		NULL);
	this->runAction(action);
	isHeroMoving = true;
}

void Hero::onMoveDone(CCNode* pTarget, void* data)
{
	//void*תΪintٴintתö
	int direction = (int) data;
	setFaceDirection((HeroDirection)direction);
	isHeroMoving = false;
	sGlobal->gameLayer->setSceneScrollPosition(this->getPosition());
}

void Hero::setFaceDirection(HeroDirection direction)
{
	heroSprite->setTextureRect(CCRectMake(0,32*direction,32,32));
}

//жײ
CollisionType Hero::checkCollision(CCPoint heroPosition) 
{
	//cocos2d-xתΪTilemap
	targetTileCoord = sGlobal->gameMap->tileCoordForPosition(heroPosition);
	//ʿ곬ͼ߽磬kWallֹͣƶ
	if (heroPosition.x < 0 || targetTileCoord.x > sGlobal->gameMap->getMapSize().width - 1 || targetTileCoord.y < 0 || targetTileCoord.y > sGlobal->gameMap->getMapSize().height - 1)
		return kWall;
	//ȡǽڲӦͼID
	int targetTileGID = sGlobal->gameMap->getWallLayer()->tileGIDAt(targetTileCoord);
	//ͼIDΪ0ʾǽ
	if (targetTileGID) {
		return kWall;
	}
	//ȡӦͼID
	targetTileGID = sGlobal->gameMap->getEnemyLayer()->tileGIDAt(targetTileCoord);
	//ͼIDΪ0ʾй
	if (targetTileGID) {
		//ʼս
		fight();
		return kEnemy;
	}
	//ȡƷӦͼID
	targetTileGID = sGlobal->gameMap->getItemLayer()->tileGIDAt(targetTileCoord);
	//ͼIDΪ0ʾƷ
	if (targetTileGID) {
		//ʰȡƷ
		pickUpItem();
		return kItem;
	}
	//ȡŲӦͼID
	targetTileGID = sGlobal->gameMap->getDoorLayer()->tileGIDAt(targetTileCoord);
	//ͼIDΪ0ʾ
	if (targetTileGID) {
		//
		openDoor(targetTileGID);
		return kDoor;
	}
	//npcֵвѯ
	CCString* index =CCString::createWithFormat("%f", targetTileCoord.x + targetTileCoord.y * sGlobal->gameMap->getMapSize().width);
	NPC *npc = (NPC*)sGlobal->gameMap->npcDict->objectForKey(index->getCString());
	if (npc != NULL)
	{
		actWithNPC();
		return kNPC;
	}
	//Teleportֵвѯ
	Teleport *teleport = (Teleport*)sGlobal->gameMap->teleportDict->objectForKey(index->getCString());
	if (teleport != NULL)
	{
		doTeleport(teleport);
		return kTeleport;
	}
	//ͨ
	return kNone;
}

//ʼս
void Hero::fight()
{
	//ѾսУظս
	if (isHeroFighting)
		return;
	isHeroFighting = true;
	//ʾܵЧ
	sGlobal->gameMap->showEnemyHitEffect(targetTileCoord);
	//ʾʧֵüһ
	char temp[30] = {0};
	sprintf(temp, "lost hp: -%d", 100);
	sGlobal->gameLayer->showTip(temp, getPosition());
	//ʾսľΪɼ
	fightSprite->setVisible(true);
	//ʾսλΪʿ͹м
	CCPoint pos = ccp((targetPosition.x - getPosition().x) / 2 + 16, (targetPosition.y - getPosition().y) / 2 + 16);
	fightSprite->setPosition(pos);
	//ս
	CCAction* action = CCSequence::create(
		sAnimationMgr->createAnimate(aFight),
		CCCallFuncN::create(this, callfuncN_selector(Hero::onFightDone)),
		NULL);
	fightSprite->runAction(action);
}
//սĻص
void Hero::onFightDone(CCNode* pSender)
{
	//ɾӦͼ飬ʾѾ
	sGlobal->gameMap->getEnemyLayer()->removeTileAt(targetTileCoord);
	isHeroFighting = false;
	fightSprite->setVisible(false);
}
//ʰȡƷ
void Hero::pickUpItem()
{
	//ʾʾϢ
	sGlobal->gameLayer->showTip("get an item, hp +100", this->getPosition());
	//ƷӵͼƳ
	sGlobal->gameMap->getItemLayer()->removeTileAt(targetTileCoord);
}
//
void Hero::openDoor(int gid)
{
	//ڱ򷵻
	if (isDoorOpening)
		return;
	//ڱŵĳʼGID
	targetDoorGID = gid;
	isDoorOpening = true;
	//ʱŶ
	schedule(schedule_selector(Hero::updateOpenDoorAnimation), 0.1f);
}
//¿Ŷ
void Hero::updateOpenDoorAnimation(float dt)
{
	//㶯һ֡ͼIDTileMapͼŷʽǺ1ÿͬλõͼIDÿͼĸ
	int nextGID = sGlobal->gameMap->getDoorLayer()->tileGIDAt(targetTileCoord) + 4;
	//˵֡ͽǰλõͼɾȡʱ
	if (nextGID - targetDoorGID > 4 * 3) {
		sGlobal->gameMap->getDoorLayer()->removeTileAt(targetTileCoord);
		unschedule(schedule_selector(Hero::updateOpenDoorAnimation));
		isDoorOpening = false;
	} else {
		//¶һ֡
		sGlobal->gameMap->getDoorLayer()->setTileGID(nextGID, targetTileCoord);
	}
}
//NPC
void Hero::actWithNPC()
{
	sGlobal->gameLayer->showTip("talking with npc", getPosition());
}
//͵߼
void Hero::doTeleport(Teleport *teleport)
{
	//Ӵ͵кȥĿͼĲ
	sGlobal->currentLevel = teleport->targetMap;
	//ȡʿµͼеʼλ
	sGlobal->heroSpawnTileCoord = teleport->heroTileCoord;
	//ʼлϷͼ
	sGlobal->gameScene->switchMap();
}




