#include "GameLayer.h"

GameLayer::GameLayer(void)
{
	sGlobal->gameLayer = this;
}

GameLayer::~GameLayer(void)
{
	this->unscheduleAllSelectors();
}

bool GameLayer::init()
{
	bool bRet = false;
	do 
	{
		//tmxͼ
		char temp[20];
		sprintf(temp, "%d.tmx", sGlobal->currentLevel);
		map = GameMap::gameMapWithTMXFile(temp);
		addChild(map, kZMap, kZMap);

		//Heroľ̬ʵ
		hero = Hero::heroWithinLayer();
		//Heroʼλ
		hero->setPosition(map->positionForTileCoord(sGlobal->heroSpawnTileCoord));
		//HeroGameLayer
		addChild(hero, kZHero, kZHero);

		schedule(schedule_selector(GameLayer::update));

		bRet = true;
	} while (0);

	return bRet;
	//return true;
}

void GameLayer::update(float dt)
{
	//ʿ״̬Ҫ³λ
	if (hero->isHeroMoving){
		setSceneScrollPosition(hero->getPosition());
	}
}

//ʿǰλϢƶӦλ
void GameLayer::setSceneScrollPosition(CCPoint position)
{
	//ȡĻߴ
	CCSize screenSize = CCDirector::sharedDirector()->getWinSize();
	//TilemapĿߣλ
	CCSize mapSizeInPixel = CCSizeMake(map->getMapSize().width * map->getTileSize().width, 
		map->getMapSize().height * map->getTileSize().height);
	//ȡʿǰxĻеxֵʿxֵϴ
	float x = MAX(position.x, screenSize.width / 2.0f);
	float y = MAX(position.y, screenSize.height / 2.0f);
	//ͼܿȴĻȵʱпܹ
	if (mapSizeInPixel.width  > screenSize.width)
	{
		//벻ܳͼܿȥĻ1/2
		x = MIN(x, mapSizeInPixel.width - screenSize.width / 2.0f);
	}
	if (mapSizeInPixel.height > screenSize.height)
	{
		y = MIN(y, mapSizeInPixel.height - screenSize.height / 2.0f);
	}
	//ʿʵλ
	CCPoint heroPosition = ccp(x, y);
	//Ļеλ
	CCPoint screenCenter = ccp(screenSize.width/2.0f, screenSize.height/2.0f);
	//ʿʵλúصλõľ
	CCPoint scrollPosition = ccpSub(screenCenter, heroPosition);
	//ƶӦλ
	this->setPosition(scrollPosition);
	CCLog("%f,%f", scrollPosition.x, scrollPosition.y);
}

//ʾʾϢ
void GameLayer::showTip(const char *tip, CCPoint startPosition)
{
	//½һıǩ
	CCLabelTTF *tipLabel = CCLabelTTF::create(tip, "Arial", 20);
	tipLabel->setPosition(ccpAdd(startPosition, ccp(16, 16)));
	this->addChild(tipLabel, kZTip,kZTip);
	//嶯Ч
	CCAction* action = CCSequence::create(
		CCMoveBy::create(0.5f, ccp(0, 32)),
		CCDelayTime::create(0.5f),
		CCFadeOut::create(0.2f),
		CCCallFuncN::create(this, callfuncN_selector(GameLayer::onShowTipDone)),
		NULL);
	tipLabel->runAction(action);
}

//ʾϢʾĻص
void GameLayer::onShowTipDone(CCNode* pSender)
{
	//ɾıǩ
	this->getChildByTag(kZTip)->removeFromParentAndCleanup(true);
}