#include "AnimationManager.h"

DECLARE_SINGLETON_MEMBER(AnimationManager);

AnimationManager::AnimationManager()
{
}

AnimationManager::~AnimationManager()
{
	//CCDirectorԼAnimationCache
	//CCAnimationCache::purgeSharedAnimationCache();
}

bool AnimationManager::initAnimationMap()
{
	char temp[20];
	sprintf(temp, "%d", aDown);
	//ʿߵĶ
	CCAnimationCache::sharedAnimationCache()->addAnimation(createHeroMovingAnimationByDirection(kDown), temp);
	sprintf(temp, "%d", aRight);
	//ʿߵĶ
	CCAnimationCache::sharedAnimationCache()->addAnimation(createHeroMovingAnimationByDirection(kRight), temp);
	sprintf(temp, "%d", aLeft);
	//ʿߵĶ
	CCAnimationCache::sharedAnimationCache()->addAnimation(createHeroMovingAnimationByDirection(kLeft), temp);
	sprintf(temp, "%d", aUp);
	//ʿߵĶ
	CCAnimationCache::sharedAnimationCache()->addAnimation(createHeroMovingAnimationByDirection(kUp), temp);
	//ս
	sprintf(temp, "%d", aFight);
	CCAnimationCache::sharedAnimationCache()->addAnimation(createFightAnimation(), temp);
	//NPC
	CCAnimationCache::sharedAnimationCache()->addAnimation(createNPCAnimation(), "npc0");
	return true;
}

CCAnimation* AnimationManager::createHeroMovingAnimationByDirection(HeroDirection direction)
{
	CCTexture2D *heroTexture = CCTextureCache::sharedTextureCache()->addImage("hero.png");
	CCSpriteFrame *frame0, *frame1, *frame2, *frame3;
	//ڶʾʾx, y, width, heightdirectionȷʾy
	frame0 = CCSpriteFrame::createWithTexture(heroTexture, cocos2d::CCRectMake(32*0, 32*direction, 32, 32));
	frame1 = CCSpriteFrame::createWithTexture(heroTexture, cocos2d::CCRectMake(32*1, 32*direction, 32, 32));
	frame2 = CCSpriteFrame::createWithTexture(heroTexture, cocos2d::CCRectMake(32*2, 32*direction, 32, 32));
	frame3 = CCSpriteFrame::createWithTexture(heroTexture, cocos2d::CCRectMake(32*3, 32*direction, 32, 32));
	CCArray *animFrames = new CCArray(4);
	animFrames->addObject(frame0);
	animFrames->addObject(frame1);
	animFrames->addObject(frame2);
	animFrames->addObject(frame3);
	//0.05fʾÿ֡ļ
	CCAnimation* animation = CCAnimation::createWithSpriteFrames(animFrames, 0.05f);
	animFrames->release();
	return animation;
}

//սģ
CCAnimation* AnimationManager::createFightAnimation()
{
	//ÿ֡
	int fightAnim[] = 
	{
		4,6,8,10,13,15,17,19,20,22
	};
	CCArray *animFrames = new CCArray();
	CCTexture2D *texture = CCTextureCache::sharedTextureCache()->addImage("sword.png");
	CCSpriteFrame *frame;
	int x, y;
	for (int i = 0; i < 10; i++) 
	{
		//ÿ֡еƫ
		x = fightAnim[i] % 5 - 1;
		y = fightAnim[i] / 5;
		frame = CCSpriteFrame::createWithTexture(texture, cocos2d::CCRectMake(192*x, 192*y, 192, 192));
		//1719֡y-8ƫ
		if (fightAnim[i] == 17 || fightAnim[i] == 19)
		{
			frame->setOffsetInPixels( ccp(0, -8) );
		}
		animFrames->addObject(frame);
	}
	CCAnimation* animation = CCAnimation::createWithSpriteFrames(animFrames, 0.1f);
	animFrames->release();
	return animation;
}

CCAnimation* AnimationManager::createNPCAnimation()
{
	CCTexture2D *heroTexture = CCTextureCache::sharedTextureCache()->addImage("npc.png");
	CCSpriteFrame *frame0, *frame1, *frame2, *frame3;
	//ڶʾʾx, y, width, heightdirectionȷʾy
	frame0 = CCSpriteFrame::createWithTexture(heroTexture, cocos2d::CCRectMake(32*0, 0, 32, 32));
	frame1 = CCSpriteFrame::createWithTexture(heroTexture, cocos2d::CCRectMake(32*1, 0, 32, 32));
	frame2 = CCSpriteFrame::createWithTexture(heroTexture, cocos2d::CCRectMake(32*2, 0, 32, 32));
	frame3 = CCSpriteFrame::createWithTexture(heroTexture, cocos2d::CCRectMake(32*3, 0, 32, 32));
	CCArray *animFrames = new CCArray(4);
	animFrames->addObject(frame0);
	animFrames->addObject(frame1);
	animFrames->addObject(frame2);
	animFrames->addObject(frame3);
	//0.05fʾÿ֡ļ
	CCAnimation* animation = CCAnimation::createWithSpriteFrames(animFrames, 0.2f);
	animFrames->release();

	return animation;
}

//ȡָģ
CCAnimation* AnimationManager::getAnimation(int key)
{
	char temp[20];
	sprintf(temp, "%d", key);
	return CCAnimationCache::sharedAnimationCache()->animationByName(temp);
}

//ȡһָģʵ
CCAnimate* AnimationManager::createAnimate(int key)
{
	//ȡָģ
	CCAnimation* anim = getAnimation(key);
	if(anim)
	{
		//ݶģһʵ
		return cocos2d::CCAnimate::create(anim);

	}
	return NULL;
}

//ȡһָģʵ
CCAnimate* AnimationManager::createAnimate(const char* key)
{
	//ȡָģ
	CCAnimation* anim = CCAnimationCache::sharedAnimationCache()->animationByName(key);
	if(anim)
	{
		//ݶģһʵ
		return cocos2d::CCAnimate::create(anim);
	}
	return NULL;
}